Package org.springframework.aop.framework

# Interface AopProxy

public interface AopProxy
Delegate interface for a configured AOP proxy, allowing for the creation of actual proxy objects.

Out-of-the-box implementations are available for JDK dynamic proxies and for CGLIB proxies, as applied by `DefaultAopProxyFactory`.

Author:
  Rod Johnson, Juergen Hoeller
See Also:
  - `DefaultAopProxyFactory`

## Method Summary

Modifier and Type
Method
Description
`Object`
`getProxy()`
Create a new proxy object.
`Object`
`getProxy(ClassLoader classLoader)`
Create a new proxy object.
`Class<?>`
`getProxyClass(ClassLoader classLoader)`
Determine the proxy class.

## Method Details

### getProxy

Object getProxy()
Create a new proxy object.

Uses the AopProxy's default class loader (if necessary for proxy creation): usually, the thread context class loader.

Returns:
  the new proxy object (never `null`)
See Also:
  - `Thread.getContextClassLoader()`

### getProxy

Object getProxy(@Nullable ClassLoader classLoader)
Create a new proxy object.

Uses the given class loader (if necessary for proxy creation). `null` will simply be passed down and thus lead to the low-level proxy facility's default, which is usually different from the default chosen by the AopProxy implementation's `getProxy()` method.

Parameters:
  `classLoader` - the class loader to create the proxy with (or `null` for the low-level proxy facility's default)
Returns:
  the new proxy object (never `null`)

### getProxyClass

Class<?> getProxyClass(@Nullable ClassLoader classLoader)
Determine the proxy class.

Parameters:
  `classLoader` - the class loader to create the proxy class with (or `null` for the low-level proxy facility's default)
Returns:
  the proxy class
Since:
  6.0